#include "DIALOG.h"

extern GUI_CONST_STORAGE GUI_BITMAP bmIcon1;
extern GUI_CONST_STORAGE GUI_BITMAP bmIcon2;
extern GUI_CONST_STORAGE GUI_BITMAP bmIcon3;

const void * pBitmaps[] = { &bmIcon1, &bmIcon2, &bmIcon3 };
int _xPos = 0, _x0_left, _x0_right, _scale, _anchor, _Index, _Sel;

void _CalcScaleAndAnchor(int x0, int * pScale, int * pAnchor) {
	if ((x0 <= 0) || (x0 > 256)) {
		*pScale = 500;
		*pAnchor = -64;
	}
	else
		if ((x0 > 0) && (x0 <= 128)) {
			*pScale = (int)(x0 * 3.9f) + 500;
			*pAnchor = x0 / 2 - 64;
		}
		else
			if ((x0 > 128) && (x0 <= 256)) {
				*pScale = (int)(x0 * -3.9f) + 1500;
				*pAnchor = -x0 / 2 + 64;
			}
}

void _OnPaint(WM_MESSAGE * pMsg) {
	_x0_left = _xPos;
	_x0_right = _xPos + 128;

	_Index = 0;
	while (_x0_left > -128) {
		_CalcScaleAndAnchor(_x0_left, &_scale, &_anchor);
		GUI_DrawBitmapEx(pBitmaps[_Index], _x0_left, 0, _anchor, _anchor, _scale, _scale);
		_x0_left -= 128;
		_Index--;
		if (_Index < 0)
			_Index += 3;			
	}

	_Index = 1;
	while (_x0_right < 384) {
		_CalcScaleAndAnchor(_x0_right, &_scale, &_anchor);
		GUI_DrawBitmapEx(pBitmaps[_Index], _x0_right, 0, _anchor, _anchor, _scale, _scale);
		_x0_right += 128;
		_Index++;
		if (_Index > 2)
			_Index -= 3;
	}
}

void _OnMotion(WM_MESSAGE * pMsg) {
	int _xPos2;
	WM_MOTION_INFO * pInfo;

	pInfo = (WM_MOTION_INFO *)pMsg->Data.p;

	switch (pInfo->Cmd) {
	case WM_MOTION_INIT:
		pInfo->Flags = WM_CF_MOTION_X | WM_MOTION_MANAGE_BY_WINDOW;
		pInfo->SnapX = 128;
		break;
	case WM_MOTION_MOVE:
		_xPos += pInfo->dx;
		if (_xPos >= 384)
			_xPos = 0;
		if (_xPos <= -384)
			_xPos = 0;

		if (pInfo->FinalMove) {
				_Sel = 1 - _xPos / 128;
				if (_Sel < 0)
					_Sel += 3;
				if (_Sel > 2)
					_Sel -= 3;
		}

		WM_Invalidate(pMsg->hWin);
		break;
	case WM_MOTION_GETPOS:
		pInfo->xPos = _xPos;
		break;
	}
}

void _cbMenu(WM_MESSAGE * pMsg) {
	switch (pMsg->MsgId) {
	case WM_MOTION:
		_OnMotion(pMsg);
		break;
	case WM_PAINT:
		_OnPaint(pMsg);
		break;
	default:
		WM_DefaultProc(pMsg);
		break;
	}
}

void MainTask(void) {
	GUI_Init();

	WM_MULTIBUF_Enable(1);
	WM_SetDesktopColor(GUI_LIGHTGRAY);
	WM_MOTION_Enable(1);

	WM_CreateWindow(48, 72, 384, 128, WM_CF_SHOW | WM_CF_HASTRANS, _cbMenu, 0);	
	
	while (1) {
		GUI_Delay(50);
	}
}